<template>
  <span dbtoolbar v-if='activeDatabase' :database='activeDatabase' @click='changeDatabase'>{{activeDatabase}}<br><span small>database</span></span>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';
import { store } from '../../store';
import axios from '../../lib/axios';
import to from '../../lib/to';
import { setTimeout } from 'timers';
import { notify } from '../app/alerting';
type databases = 'development' | 'production';
@Component({
  components: {
  },
})
export default class extends Vue {
  private databases: {[s in databases]: boolean} = {
    development: false,
    production: false,
  };

  public mounted() {
    this.getDatabases();
  }

  private async changeDatabase() {
    const database: databases = this.getActiveDatabase() === 'development' ? 'production' : 'development';
    if (!this.databases[database]) {
      console.error(`desired database ${database} is not available`);
      notify({
        type: 'error',
        message: `could not switch to ${database} database. It is not available.`,
      });
    } else {
      const [, err] = await to(store.dispatch.auth('renew', {database}));
      if (err) {
        notify({
          type: 'error',
          message: `could not switch to ${database} database: ${err.message}`,
        });
        return;
      }
      store.commit.database('resetSubsystemTables');
      store.commit.database('clearCache');
      store.dispatch.database('getSubsystemTables');
    }
  }

  get store() {
    return store;
  }

  get activeDatabase(): databases | '' {
    return this.getActiveDatabase();
  }

  private getActiveDatabase() {
    const userData = store.state.auth.userData;
    const userDatabase = userData && userData.l1ce && userData.l1ce.database;
    if (userDatabase) {
      return userDatabase;
    } else {
      if (this.databases.development) {
        return 'development';
      } else if (this.databases.production) {
        return 'production';
      } else {
        return '';
      }
    }
  }

  private async getDatabases() {
    const {data} = await store.dispatch.database('cachedAxios', {url: '/api/v0/db/capabilities'});
    this.databases = {
      development: data.development || false,
      production: data.production || false,
    };
  }
}
</script>

<style scoped lang="scss">
[dbtoolbar] {
  text-align: center;
  &[database='development'] {
    background: $yellow;
  }

  [small] {
    font-size: .8em;
  }
}
</style>
